/* $Id: Request.js,v 1.77.4.3 2008/12/29 11:05:56 srikrishnan Exp $ */

/**
 * Request related scripts should be added here.
 */

// USED IN : Add / Edit WorkOrder
function resetWODescription(form) {
	parent["editor"].setHTML(form.description.value);
	var resDisplayed = document.getElementById("resolutionBox");
	if(resDisplayed != null) {
		if(resDisplayed.style.display == 'block') {
			parent["editor2"].setHTML(form.resolution.value);
		}
	}
}

function changeWOTemplate(selObj) {
	if(parent["workOrderId"] != null) {
		document.location="/WorkOrder.do?woMode=editWO&reqTemplate=" + selObj.value + "&woID=" + parent["workOrderId"];
	}
	else {
		document.location="/WorkOrder.do?reqTemplate=" + selObj.value;
	}
}

var resShown = false;

function toggleResolution() {
	var e = $('resolutionBox');
    	var icon = $('bulletresolution');
	if(e != null && e.style.display == 'block') {
		e.style.display='none';
        	icon.src="/images/collapsearrow.gif";
	}
	else {
		e.style.display='block';
        	icon.src="/images/expandarrow.gif";
		if(resShown == false) {
			SDP_CreateSecondHTMLArea('HTMLResolution',' insertimage  spellcheck ');
			resShown = true;
		}
	}
}

// USED IN : WorkOrder List view
function confirmRequestDeleteFromList(form, checkBoxCompName, deleteConfirmObj, selectRowObj, additionalParams) {
	if(confirmDelete(form, checkBoxCompName, deleteConfirmObj.innerHTML,selectRowObj.innerHTML)) {
		form.action = form.action + additionalParams;
		handleStateForForm(form);
		form.submit();
	}
	else {
		return false;
	}
}


function checkCloseAccept(form, box) {
    if(arguments.length == 0) {
        var html_src = $('wotoClose').innerHTML;
        showDialog(html_src, "title=" + getMessageForKey("sdp.requests.viewrequest.closerequest"));
    }
    else {
        if(!checkForRowSelection(form, box)) {
            alert(getMessageForKey('sdp.requests.listview.close.choose'));
            return false;
        }
        var selBox = $('woListBox@@@');
        selBox.options.length=0;
        var idx = 0;
        var cbArr = document.getElementsByName('checkbox');
        for(i=0; i<cbArr.length; i++){
            var cb = cbArr[i];
            if(cb.checked == true) {
                var val = cb.value;
                selBox.options[idx] = new Option(val, val, true, true);
                //selBox.options[idx].selected =true;       // for IE
                idx++;
            }
        }
        var html_src = $('wostoclose').innerHTML;
        html_src = html_src.replace(/@@@/g, '');
        //alert(html_src);
        showDialog(html_src, "title=" + getMessageForKey("sdp.requests.viewrequest.closerequest"));
    }
}


function submitCloseAccepted(form, additionalParams) {
	form.action = form.action + additionalParams;
	var selectElement = $('woListBox');
    if(selectElement) {
        for(i = 0; i < selectElement.options.length; i++) {
            selectElement.options[i].selected = true;
        }
    }
	handleStateForForm(form);
	form.submit();
	return true;
}

function checkWOSelection(form, box, additionalParams) {
	form.action = form.action + additionalParams;
	if(!checkForRowSelection(form, box)) {
		if(additionalParams!=null && additionalParams.substring(1,5) == "pick") {
			alert(getMessageForKey("sdp.requests.listview.pickup.choose"));
		}
		else if(additionalParams!=null && additionalParams.substring(1,5) == "clos") {
			alert(getMessageForKey("sdp.requests.listview.close.choose"));
		}
		else{
			alert(getMessageForKey("sdp.requests.viewrequest.jserror2"));
		}
		return false;
	}
	handleStateForForm(form);
	form.submit();
	return true;
}

function checkMergeSelection(form, box, additionalParams) {
	form.action = form.action + additionalParams;
	if(!isWOSelectedForMerge(form, box)) {
		return false;
	}
	handleStateForForm(form);
	form.submit();
	return true;
}

function isWOSelectedForMerge(thisForm1,checkBoxCompName) {
	returnValue = false;
	isSelected = false;
	temp=false;
	for(var i=0; i<thisForm1.elements.length; i++) {
		if(thisForm1.elements[i].name == checkBoxCompName) {
			if(thisForm1.elements[i].checked) {
				if(!isSelected) {
					isSelected=true;
				}
				else {
					temp=true;
				}
			}
		}
	}
	if(temp) {
		returnValue = true;
	}
	if(!isSelected) {
		alert(getMessageForKey("sdp.requests.listview.merge.choose"));
	}
	else if(isSelected && !temp) {
		alert(getMessageForKey("sdp.requests.listview.merge.requests.choose"));
	}
	return returnValue;
}

function validateWOAssign(thisForm, module) {
	if(thisForm.technician.value=="0") {
		if(module != null && module == "Calendar") {
			alert(getMessageForKey("sdp.calendar.viewrequest.jserror1"));
		}
		else {
			alert(getMessageForKey("sdp.requests.viewrequest.jserror1"));
		}
		thisForm.technician.focus();
		return false;
	}
	if(!checkForRowSelection(thisForm,'checkbox')) {
		if(module != null && module == "Calendar") {
			alert(getMessageForKey("sdp.calendar.viewrequest.jserror2"));
		}
		else {
			alert(getMessageForKey("sdp.requests.listview.assign.choose"));
		}
		return false;
	}
	var objs = thisForm.elements;
	var action1 = thisForm.action;
	var url = "";
	for(var i=0; i<objs.length; i++) {
		var ele = objs[i];
		if(ele.name == 'checkbox') {
			var attr = ele.getAttribute('module');
			if(ele.checked) {
				if(attr == "Request") {
					url = url + "&woId=" + ele.value;
				}
				else if(attr == "Problem") {
					url = url + "&PROBLEMID=" + ele.value;
				}
				else if(attr == "Change") {
					url = url + "&CHANGEID=" + ele.value;
				}
				else if(attr == "Task") {
					url = url + "&TASKID=" + ele.value;
				}
				else if(attr == "Reminder") {
					url = url + "&remId=" + ele.value;
				}
			}
		}
	}
	thisForm.action = thisForm.action + url;
	//added in order to pass go parameter while assigning the tech to req from bulk edit.
	if(thisForm.go){
		thisForm.go.checked=true;
	}
	thisForm.submit();
	thisForm.action = action1;
	return false;
}

function validateWOBulkEdit(thisForm) {
	if(!checkForRowSelection(thisForm,'checkbox')) {
		alert(getMessageForKey("sdp.requests.listview.edit.choose"));
		return false;
	}
	checkBoxCompName = 'checkbox';
	reqIDs = new Array();
	for(var i=0; i<thisForm.elements.length; i++) {
		if(thisForm.elements[i].name == checkBoxCompName) {
			if(thisForm.elements[i].checked) {
			var reqID = thisForm.elements[i].value;
			var tempID = thisForm.elements[i].getAttribute("templateid");
			reqIDs.push(reqID+"--"+tempID);
			}
		}
	}
	reqIDs.sort();
	var reqList = reqIDs.join(",");
	NewWindow('BulkEditRequest.do?reqIDs=' + reqList,'BulkEdit','750','500','yes','center')
}

// Used In : Selectable Template tasks in Requests

function deleteWOTemplateTasks(woid, templateid)
{
  var templateID = templateid;
  var woID = woid;
  var newUrl = '/servlet/HdClientUtilServlet';
  var params = 'command=deleteWOTemplateTasks&';
  params = params + 'templateID='+templateID+'&';
  params = params + 'woID='+woID;
  var myAjax = new Ajax.Request(newUrl, {
                                method: 'get',
                                parameters: params,
                                onComplete: function(resp, jsonObj){
                                  alert(getMessageForKey("sdp.request.template.tasks.deleted.info"));
                                  closeDialog();
                                  changeWOTemplate($('template_box'));
                                }
  });
}

function cancelWOTaskDelete()
{
  closeDialog();
  changeWOTemplate($('template_box'));
}

function checkPrevTemplTask(obj)
{
  var prevTask = $('deletePrevTask');
  if(prevTask != null) {
    var html_src = prevTask.innerHTML;
    var titleText = getMessageForKey("sdp.request.template.deletetask.dialog.title");
    showDialog(html_src, titleText);
  }
  else {
    changeWOTemplate(obj);
  }
}

// Used In : Request Quick Create
function addMoreReqDetails() {
	document.getElementById('quickReq').value = 'gotoNew';
	document.QuickCreateForm.submit();
}

function editRequestCost(exectedtime,req_cost_id,technician_id,totaltime_ms,cost,created_time,created_by,window_name,window_attr) {
	var workHours = Math.floor(((totaltime_ms/1000)/60)/60);
	var workMinutes = Math.floor(((totaltime_ms/1000)/60)%60);
	var url = "RequestCharges.do?workOrderID=" + parent["WOID"];
	url += "&requestCostID=" + req_cost_id + "&technicianID=" + technician_id + "&workHours=" + workHours;
	url += "&workMinutes=" + workMinutes + "&cost=" + cost;
	url += "&createdTime=" + created_time + "&createdBy=" + created_by + "&mode=fetch&executedTime=" + exectedtime;
	var winl = (screen.width - 400) / 2;
	var wint = (screen.height - 350) / 2;
	window_attr = window_attr+',top='+wint+',left='+winl;
	url = url.replace(/\`/g,"\r\n");
	window.open(url,window_name,window_attr);
}

function editRequestCostNew(exectedtime,req_cost_id,owner_id,totaltime_ms,cost,created_time,created_by,window_name,window_attr) {
 	var techID = document.getElementById(owner_id).value;
	editRequestCost(exectedtime,req_cost_id,techID,totaltime_ms,cost,created_time,created_by,window_name,window_attr);
}

function calculateCost(formObj) {
	var index = formObj.technicianID.selectedIndex;
	var tech_cost = formObj.technicianID.options[index].id;
	tech_cost = tech_cost.split('#')[0];
	formObj.costperhour.value=tech_cost;
	if(tech_cost > 0.0) {
		var total = 0.0;
		var hour = formObj.workHours.value;
		var mins = formObj.workMinutes.value;
		if( hour > 0 ) {
			total += (hour * tech_cost);
		}
		if( mins > 0 ) {
			var tech_cost_per_min = (tech_cost / 60);
			total += (mins * tech_cost_per_min);
		}
		formObj.cost.value = total;
	}
}

function validateWOWorkLog(formObj) {
	if( formObj.workHours.value == "" ){
		formObj.workHours.value = "0";
	}
	if( formObj.workMinutes.value == "" ){
		formObj.workMinutes.value = "0";
	}
	if( formObj.cost.value == "" ){
		formObj.cost.value = "0.0";
	}

	if(formObj.technicianID.value == -1){
		alert(getMessageForKey("sdp.requests.requestcost.errorTechname"));
		return false;
	}
	if(formObj.executedTime.value == ""){
		alert(getMessageForKey("sdp.requests.requestcost.errorNoExecutedtime"));
		return false;
	}

	if(!isPositiveInteger(formObj.workHours.value)){
		alert(getMessageForKey("sdp.requests.requestcost.errorHH"));
		formObj.workHours.focus();
		return false;
	}
	else if(!isPositiveInteger(formObj.workMinutes.value)){
		alert(getMessageForKey("sdp.requests.requestcost.errorMM"));
		formObj.workMinutes.focus();
		return false;
	}
	else if(!isDouble(formObj.cost.value)){
		alert(getMessageForKey("sdp.requests.requestcost.errorCost"));
		formObj.cost.focus();
		return false;
	}
	return true;
}

function switchValues(selObj){
	var value = selObj.value;
	document.OWNERForm.group.value = value;
	document.OWNERForm.QUEUEID.value = value;
	submitGroupID(document.OWNERForm);
}
function saveGroupnTech(formObj) {
	if(document.QUEUEForm){
		document.QUEUEForm.QUEUEID.value = document.QUEUEForm.VALUE.value;
	}if(document.OWNERForm){
		document.OWNERForm.OWNERID.value = document.OWNERForm.technician.value;
		document.OWNERForm.QUEUEID.value =null;

	}if(document.QUEUEForm && document.OWNERForm){
		document.OWNERForm.QUEUEID.value = document.QUEUEForm.VALUE.value;
		document.OWNERForm.group.value=document.QUEUEForm.VALUE.value;
	}
}

function submitWOSpotEdit(formObj) {
	formObj.submit();
}

function showHideTimeSpent() {
	if(document.addResolutionForm.timeSpent.checked) {
		document.getElementById('timespentdetail').style.display='block';
	}
	else {
		document.getElementById('timespentdetail').style.display='none';
	}
}

function isWOResolutionEmpty() {
	var string=parent["editor"].getHTML();
	string = string.replace(/<br \/>/g,"\n");
	string = string.replace(/<\/p>/g,"");
	string = string.replace(/<p>/g,"\n\n");
//	string = string.replace(/(<([^>]+)>)/g,"");
	string = string.replace(/&lt;/g,"<");
	string = string.replace(/&gt;/g,">");
	string = string.replace(/&nbsp;/g,"");
	string = string.replace(/^\s*|\s*$/g, ""); // Trim. remove leading and traling white space
	if(string == ""){
		return true;
	}
	else {
		return false;
	}
}

function checkWOResAndSaveAsSolution() {
	if(isWOResolutionEmpty()) {
		alert(getMessageForKey("sdp.requests.resolution.emptyResolution"));
		return false;
	}
	else if(document.addResolutionForm.timeSpent.checked) {
		return validateWOWorkLog(document.addResolutionForm);
	}
	else {
		return true;
	}
}

function validateWOResSave() {
	var resolutionEmpty = isWOResolutionEmpty()
	// if there is nothing in the html textarea the form bean it will set the form bean to null ---document.addResolutionForm.resolution.value = str;---this statement will not work here since the value to the resolution textarea will be set finally by parent["editor"]getHTML() function.
	if(resolutionEmpty){
		parent["editor"].setHTML("");
	}
	if(document.addResolutionForm.timeSpent.checked) {
		return validateWOWorkLog(document.addResolutionForm);
	}
	else {
		if(resolutionEmpty) {
			alert(getMessageForKey("sdp.requests.resolution.emptyResolution"));
			return false;
		}
		else {
			return true;
		}
	}
}

function quickEditWO(reqID){
	document.getElementById("ProDetails").className = "hide";
	document.getElementById("ProDetInFrame").className = "show";
	initPriorityMatrix(impactID, urgencyID, priorityID, priorityEdit);

    var sCatValue, itemValue = null;
    var catVal = ($('CATEGORYID_CUR')) ? $('CATEGORYID_CUR').getAttribute('val') : 0;
    if(catVal == "null" || catVal == null || catVal == undefined) { catVal = 0; }
    if($('SUBCATEGORYID_CUR')) { sCatValue = $('SUBCATEGORYID_CUR').getAttribute('val'); }
    if($('ITEMID_CUR')) { itemValue = $('ITEMID_CUR').getAttribute('val'); }
    //console.debug("sCatValue: %s  itemValue: %s ",sCatValue,itemValue);
    //console.debug("Inline_SUBCATEGORYID ", parent.document.getElementById('Inline_SUBCATEGORYID'));
    parent.invokeCSIPopulation(parent.document.getElementById('Inline_CATEGORYID'), parent.document.getElementById('Inline_SUBCATEGORYID'), parent.document.getElementById('Inline_ITEMID'), sCatValue, itemValue, catVal);

    var sVal, gVal, tVal = 0;
    if($('SITEID_CUR'))  { sVal = ($('SITEID_CUR').getAttribute('val') == "null") ? "0" : $('SITEID_CUR').getAttribute('val'); }
    if($('QUEUEID_CUR')) { gVal = ($('QUEUEID_CUR').getAttribute('val') == "null") ? "0" : $('QUEUEID_CUR').getAttribute('val'); }
    if($('OWNERID_CUR')) { tVal = ($('OWNERID_CUR').getAttribute('val') == "null") ? "0" : $('OWNERID_CUR').getAttribute('val'); }
    parent.invokeSGTPopulation(parent.document.getElementById('Inline_SITEID'), parent.document.getElementById('Inline_QUEUEID'), parent.document.getElementById('Inline_OWNERID'), tVal, gVal, sVal);

    // call displayClientTime for all date fields
    /* var dateElems= $A(document.getElementsByTagName('img')).findAll(function(n) { return n.className == 'date' });
    dateElems.each(function(date) { displayClientTime(date.getAttribute('forFieldId')); }); */
    $$('img.date').each(function(date) { displayClientTime(date.getAttribute('forFieldId')); });
}

function replaceQuickEdit(form) {
    //console.debug("formName ", form.name);
    resetInlineEditForm(form.name);
	document.getElementById("ProDetails").className = "show";
	document.getElementById("ProDetInFrame").className = "hide";
}

function replaceReqQuickEdit() {
	parent.document.getElementById('ReqDetails').innerHTML = document.getElementById('ReqDetails_ph').innerHTML;
	document.getElementById('ReqDetails_ph').innerHTML = "";
}

function reqQuickEdit(requesterID,woID) {
    if(parent.document.getElementById('ReqDetails_ph').innerHTML == "") {
        var url = "/workorder/EditWOReqDetails.jsp?REQID=" + requesterID +" &WORKORDERID=" +woID;
        parent.document.getElementById('ReqDetails_ph').innerHTML = document.getElementById('ReqDetails').innerHTML;
        frames["ReqQuickEdit"].location.href = url;
    }
}

function updateReqQuickEdit() {
	document.location="RequesterDef.do?type=quickUpdate";
}


function showWSDetails(wsID) {
	if(wsID != null && wsID > 0) {
		parent.document.location="/ViewWSDetails.do?wsId="+wsID;
	}
	else {
		showFailureMessageAndClose("Invalid Asset ID");
	}
}

function validateReqDet(form) {
	/* if(document.WorkOrderForm.CREATEDTIME != null && !isEmpty(document.WorkOrderForm.CREATEDTIME.value)) {
		if(!checkWOCreatedTimeInline(form)) {
			return false;
		}
	}
	if(document.WorkOrderForm.DUEBYTIME != null && !isEmpty(document.WorkOrderForm.DUEBYTIME.value)) {
		if(!checkWODueByTimeInline(form)) {
			return false;
		}
	} */
	if(!checkForInlineUDFNumeric(form)) {
		alert(document.getElementById('invalidfields').innerHTML);
		return false;
	}
	parent.invokeProgressIndicator(null,'Processing. Please Wait..','progress');
	return true;
}

function validateUserDet(form) {
	var email=document.RequesterForm.EMAILID.value;
	var name=document.RequesterForm.REQUESTERID.value;
	if(isEmpty(name)) {
		alert(document.getElementById("entername").innerHTML);
		document.RequesterForm.REQUESTERID.focus();
	 	return false;
	}
	if(!isEmpty(email) && email != '-') {
		if(!emailCheck(document.RequesterForm.EMAILID)) {
			return false;
		}
	}
	if(!checkForInlineUDFNumeric(form)) {
		alert(document.getElementById('invalidfields').innerHTML);
		return false;
	}
	parent.invokeProgressIndicator(null,'Processing. Please Wait..','progress');
	return true;
}

function validateInlineFields(form) {
	str= form.FIELDNAME.value;
 	FieldName = str.substring(8,0);
	module=form.MODULE.value;
	if(module =="WO") {
		if(FieldName!=null && FieldName == "UDF_LONG") {
			if(!checkForInlineUDFNumeric(form)) {
				alert(document.getElementById('invalidfields').innerHTML);
				return false;
			}
	  	}
	}
	else if(module == "WorkOrder" ) {
		if(FieldName!=null && FieldName == "UDF_LONG") {
			if(!checkForInlineUDFNumeric(form)) {
				alert(document.getElementById('invalidfields').innerHTML);
				return false;
			}
		}
		else if(str == "EMAILID") {
			email=document.getElementsByName('VALUE')[0];
			if(!isEmpty(email.value) && email.value != '-') {
				if(!emailCheck(form.VALUE)) {
					return false;
				}
			}
		}
	}
	return true;
}

function checkForInlineUDFNumeric(form) {
	from=document.getElementById('From');
	if(from!=null && from.value == "SpotEdit") {
		num1 = form.VALUE;
		num2 = null;
		num3 = null;
		num4 = null;
	}
	else {
		num1 = form.UDF_LONG1;
		num2 = form.UDF_LONG2;
		num3 = form.UDF_LONG3;
		num4 = form.UDF_LONG4;
	}
	if(num1!=null && num1.value!=null && num1.value!='' && num1.value!=' ') {
		if(!checklong(num1)) {
			num1.focus();
			return false;
		}
	}
	if(num2!=null && num2.value!=null && num2.value!='' && num2.value!=' ') {
		if(!checklong(num2)) {
			num2.focus();
			return false;
		}
	}
	if(num3!=null && num3.value!=null && num3.value!='' && num3.value!=' ') {
		if(!checklong(num3)) {
			num3.focus();
			return false;
		}
	}
	if(num4!=null && num4.value!=null && num4.value!='' && num4.value!=' ') {
		if(!checklong(num4)) {
			num4.focus();
			return false;
		}
	}
	return true;
}



/**
function replaceAll(oldStr,findStr,repStr) {
  var srchNdx = 0;  // srchNdx will keep track of where in the whole line
                    // of oldStr are we searching.
  var newStr = "";  // newStr will hold the altered version of oldStr.
  while (oldStr.indexOf(findStr,srchNdx) != -1)
                    // As long as there are strings to replace, this loop
                    // will run.
  {
    newStr += oldStr.substring(srchNdx,oldStr.indexOf(findStr,srchNdx));
                    // Put it all the unaltered text from one findStr to
                    // the next findStr into newStr.
    newStr += repStr;
                    // Instead of putting the old string, put in the
                    // new string instead.
    srchNdx = (oldStr.indexOf(findStr,srchNdx) + findStr.length);
                    // Now jump to the next chunk of text till the next findStr.
  }
  newStr += oldStr.substring(srchNdx,oldStr.length);
                    // Put whatever's left into newStr.
  return newStr;
}
*/

function delete_request_cost(requestCostID) {
	if(confirm(getMessageForKey("sdp.requests.requestcost.errorDeleteConfirm"))) {
		var arg = "RequestCharges.do?rcMode=delete_cost&requestCostID=";
		arg = arg.concat(requestCostID);
		arg = arg.concat("&workOrderID=");
		arg = arg.concat(parent["WOID"]);
		arg = arg.concat("&woID=");
		arg = arg.concat(parent["WOID"]);
		arg = arg.concat("&woMode=viewWO");
		if(parent["FromListView"] != null) {
			arg = arg + "&fromListView=true";
		}
		document.location = arg;
	}
	else {
		return false;
	}
}


function delete_request_notes(url) {
	if(confirm(getMessageForKey("sdp.requests.viewrequest.notes.confirmDelete"))) {
		window.frames['WOFrame'].location.href=url;
	}
	else {
		return false;
	}
}

/**
 * This function is used to update the workorder details in view workorder page
 * the function will set the source of the hidden Iframe [updateIframe] to [UpdateRequestDetails.jsp]
 * along with the request ID. when the latest content from the DB is loaded in Iframe the
 * onload event will fire on which the [updateUI] function will replace the HTML
 */
function updateWorkOrderDetails() {
	updateIFrameObj = document.getElementById('updateIF');
	updateIFrameObj.src='/jsp/UpdateRequestDetails.jsp?woID=' + parent["WOID"];
}

function showCloseComments() {
	var html_src = $('closeCommentText').innerHTML;
	showDialog(html_src, "title=" + getMessageForKey("sdp.requests.close.comments.title"));
}


function deleteDraft(draftID,draftName) {
	if(confirm(getMessageForKey("sdp.common.mail.draft.delete.confirm"))) {
		var url = '/SDNotify.do?deleteDraft='+draftID;
		var xmlhttp = getXMLHttpRequest();
		xmlhttp.open("GET",url,true);
		xmlhttp.onreadystatechange=function() {
			if (xmlhttp.readyState==4) {
				effect = new Effect.SwitchOff(draftName);
				if(totalDrafts == 1) {
					document.getElementById("drafttableMain").style.visibility = "hidden";
				}
				totalDrafts--;
			}
		}
		xmlhttp.send(null);
	}
	else {
		return false;
	}
}

function sendForReview() {
    	var titleText = getMessageForKey("sdp.common.mail.draft.review.title");
	showURLInDialog("/jsp/ReviewDraft.jsp?woID=" + parent["WOID"], "title=" + titleText + ", position=absmiddle, top=50, left=400, height=240, width=450, closeOnEscKey=no");
}

function closeReviewDialog() {
	closeDialog();
}

/* function checkCloseAccept() {
	var html_src = $('wotoClose').innerHTML;
	showDialog(html_src);
} */

/* function submitCloseAccepted(form, additionalParams) {
	form.action = form.action + additionalParams;
	handleStateForForm(form);
	form.submit();
	return true;
} */

function confirmRequestDelete(deleteConfirmString) {
	if(confirmSubmit(deleteConfirmString)) {
		return true;
	}
	else {
		return false;
	}
}
// SD-14042 method takes additional args orgReqID,userId,groupID inorder to support the requester reply functionality.
function openNotificationDetails(notifyID,orgReqId,userId,groupID) {
	var key = "notify" + notifyID + "_CUR";
	if(document.getElementById(key).style.display == 'block') {
		document.getElementById(key).style.display = 'none';
	}
	else {
        document.getElementById(key).style.display = "block";
		if(document.getElementById(key).value == null){
            document.getElementById(key).value = notifyID;
		// SD-14042 orgReqID,userId,groupID are passed for updatenotifications to support requester reply.
	        url = "/workorder/UpdateNotificationDetails.jsp?notificationID="+notifyID+"&orgReqID=" + orgReqId+"&userID="+userId+"&groupID="+groupID;
	        window.open(url,"SDPHeaderFrame");
		}
	}
}
// Issue ID : SD-11561 -groupID is added inorder to make the reply threaded based on the group emailId.
function openThreadedWoDetails(woID, orgReqId,groupID) {
	var key = "requestThread" + woID + "_CUR";
 	if(document.getElementById(key).style.display == 'block') {
		document.getElementById(key).style.display = 'none';
	}
	else {
	        document.getElementById(key).style.display = "block";
		if(document.getElementById(key).value == null){
		document.getElementById(key).value = orgReqId;
		// Issue ID : SD-11561 -groupID is added inorder to make the reply threaded based on the group emailId.
		url = "/workorder/UpdateNotificationDetails.jsp?woID="+woID + "&orgReqID=" + orgReqId+"&groupID="+groupID;
		if(parent["FromListView"] != null) {
			url = url + "&fromListView=true";
		}
		window.open(url,"SDPHeaderFrame");
		}
	}
}

function displayCopyForm(woId) {
	var tableCont = "<table width='100%' border='0' cellspacing='0' cellpadding='0'><tr><td><form name='CopyWorkOrderForm' method='post' action='/CopyWorkOrder.do' target='SDPHeaderFrame'><input type='hidden' name='workOrderID' value='";
	tableCont = tableCont.concat(woId);
	tableCont = tableCont.concat("'><table bgcolor='#F1F1F1' width='100%' border='0' cellpadding='4' cellspacing='0' class='dbborder'><tr><td colspan='2'><br>");
	tableCont = tableCont.concat(getMessageForKey("sdp.requests.copy.message"));
	tableCont = tableCont.concat("<br><br></td></tr><tr><td nowrap width='50%'>");
	tableCont = tableCont.concat(getMessageForKey("sdp.requests.copy.number"));
	tableCont = tableCont.concat("</td><td><input type='text' name='noOfCopies' style='width: 150px;' class='formStyle'/></td></tr><tr><td colspan='2'><br></td></tr><tr><td align='right' class='headligreenbg'><input type='submit' name='submitCopy' class='formStylebutton' onclick='javascript:return parent.validateCopyForm();' value=\"");
	tableCont = tableCont.concat(getMessageForKey("sdp.common.copy"));
	tableCont = tableCont.concat("\"/></td><td class='headligreenbg'><button onclick='closeDialog();return false;' class='formstylebutton'>");
	tableCont = tableCont.concat(getMessageForKey("sdp.common.cancel"));
	tableCont = tableCont.concat("</button></td></tr></table></form></td></tr></table>");
	showDialog(tableCont, "width=350,title=" + getMessageForKey("sdp.requests.viewrequest.copyrequest"))
}

function validateCopyForm() {
	val = document.CopyWorkOrderForm.noOfCopies.value;
	if(val!=null) {
		if(val.length>=2) {
                        alert(getMessageForKey("sdp.requests.copy.jserror1"));
			return false;
		}
		if(val=='0') {
                        alert(getMessageForKey("sdp.requests.copy.jserror2"));
			return false;
		}
	}
	if(!checkinteger(document.CopyWorkOrderForm.noOfCopies)) {
		alert(getMessageForKey("sdp.requests.copy.jserror3"));
		return false;
	}
	return true;
}

function validateNotesForm(thisForm) {
	var thetxt = trimAll(thisForm.notesText.value);
	if(thetxt=="") {
		alert(getMessageForKey("sdp.request.notes.addnotes.jserror"));
		thisForm.notesText.value = "";
		thisForm.notesText.focus();
		return false;
	}
}

function closeAttachment(formVal,val,vv,size,module) {
	top.window.opener.assignVal(formVal,val,unescape(vv),size,module);
	window.close();
}

function validateAttach() {
	var str=document.form1.filePath.value;
	if((str=="")||(str.charAt(str.length-1)=="/")) {
		return false;
	}
	else {
		document.form1.filename.value=str;
	}
	return true;
}

function checkUserExists(form)
{
	reqFrom = form;
	if(window.XMLHttpRequest)
	{
		reqObj = new XMLHttpRequest();
	}
	else if(window.ActiveXObject)
	{
		reqObj = new ActiveXObject("Microsoft.XMLHTTP");
	}
	if(reqObj.readyState == 4 || reqObj.readyState == 0)
	{
		var str = document.getElementById('reqSearch').value;
		reqObj.open("GET", '/servlet/AJaxServlet?action=checkUser&search='+encodeURIComponent(str), true);
		reqObj.onreadystatechange = handleCheckUser;
		reqObj.send(null);
	}
}

function handleCheckUser()
{
	if(reqObj!=null && reqObj.readyState==4)
	{
		var str = reqObj.responseText;
        //alert(str);
        var data = str.evalJSON();
		if(data && data.USER_PRESENT == 'true') {
            if(data.IN_SITE == 'true') {
                reqFrom.submit();
            }
            else {
                alert(getMessageForKey("sdp.request.add.error.notinsite"));
                reqFrom.reqName.focus();
            }
		}
		else {
			if(confirmSubmit(document.getElementById('enterreqvalidname').innerHTML)) {
				reqFrom.submit();
			}
			else {
				reqFrom.reqName.focus();
			}
		}
	}
}

var reqFrom = null;
function fieldCheck(form)
{
	var fromObj = form.createdTime;
	var toObj = form.dueByDate;
	if(fromObj != null && toObj != null) {
		var res = checkTime(fromObj, toObj);
		if(!res) {
			alert(getMessageForKey("sdp.requests.newrequest.jserror1"));
			return false;
		}
	}
    try
    {
        var formName = form.name;
        var documentForm = eval("document." + formName);
        //console.log("Form name : ",documentForm.name);      // DEBUG statement. will print in FireBug 1.0 console

        // {{{
        if(documentForm.name == "WorkOrderForm")
        {
            // the following code is required to transform the plain text
            // to html text when the user had toggled to plain editing
            var descVal = parent["editor"].getHTML();
            descVal = descVal.replace(/\n/g, "<br />");
            form.description.value = descVal;

            // Note: Resolution not present for requester login
            //console.debug("resolution ", $('resoutionText'));
            var resolutionDisplyed = $('resolutionBox');
            if(resolutionDisplyed != null)
            {
                if(resolutionDisplyed.style.display == 'block')
                {
                    var resolutionBox = $('HTMLResolution');
                    if(resolutionBox != null)
                    {
                        resolutionBox.value = parent["editor2"].getHTML();
                        if(resolutionBox.value == "&nbsp;")
                        {
                            resolutionBox.value = "";
                        }
                    }
                }
            }
            // TODO: The value is coming as &nbsp; if no data is entered. Need to check why this is happening. As a fix, if the data contains &nbsp; we replace it as "". Root Cause to be analysed later.
            if(form.description.value == "&nbsp;") {
                form.description.value = "";
            }
            /* if(form.resolution.value == "&nbsp;") {
                form.resolution.value = "";
            } */

            // check name
            //if(trim(document.WorkOrderForm.reqName.value)=="")
            var reqesterName = eval(documentForm.name + ".reqName");
            if(trim(reqesterName.value)=="")
            {
                alert(document.getElementById('enterreqname').innerHTML)
                //document.WorkOrderForm.reqName.focus();
                reqesterName.focus();
                return false;
            }

            // check title
            //if(trim(document.WorkOrderForm.title.value)=="")
            var reqTitle = eval(documentForm.name + ".title");
            if(trim(reqTitle.value)=="")
            {
                alert(document.getElementById('enterreqtitle').innerHTML)
                //document.WorkOrderForm.title.focus();
                reqTitle.focus();
                return false;
            }
        } // }}}only for WorkOrderForm

        if(!checkForUDFNumeric())
        {
            alert(document.getElementById('invalidudf').innerHTML);
            return false;
        }


        for(var i=0;i<mandatoryListArray.length;i++)
        {
            //console.log("mandatoryArrayList is", mandatoryListArray.length)
            //var field = eval('document.WorkOrderForm.'+ mandatoryListArray[i]);
            var field = eval(documentForm.name + "." + mandatoryListArray[i]);
            //debugger; field.selectedIndex==0 || field.selectedIndex==-1 ||
            //console.log("selectedIndex", field.selectedIndex, field.value);
            // Note: the check has to be based on the option value and not on the selected index
            if(field.name == 'workstationID'){
                if(field.options){
                    if((field.options[field.selectedIndex].value=='0') || (field.options[field.selectedIndex].value=='') || (field.options[field.selectedIndex].value=='-'))
                    {
                		alert(mandatoryListArrayDisp[i].replace(/&#39;/g,"")  + " "+document.getElementById("mandatoryUDF").innerHTML);
                		field.focus();
                		return false;
            		}
                }
                else if(field.value =='' || field.value =='-' || field.value == 'null' || field.value == '0')
                {
                    alert(mandatoryListArrayDisp[i].replace(/&#39;/g,"") + " "+document.getElementById("mandatoryUDF").innerHTML);
                    return false;
                }
            }
            else{
            	if((field.options[field.selectedIndex].value=='0') || (field.options[field.selectedIndex].value=='') || (field.options[field.selectedIndex].value=='-'))
            	{
                	alert(mandatoryListArrayDisp[i].replace(/&#39;/g,"") + " "+document.getElementById("mandatoryUDF").innerHTML);
                	field.focus();
                	return false;
            	}
            }
        }
        for(var i=0;i<mandatoryArray.length;i++)
        {
            //console.log("mandatoryArrayList is", mandatoryArray.length)
            //var field = eval('document.WorkOrderForm.'+mandatoryArray[i]);
            var field = eval(documentForm.name + "." + mandatoryArray[i]);
            //console.debug("field",field);
            if(documentForm.name == "BulkEditRequestForm" && (field.name == "description"  || field.name == "impactDetails" || (field.name.indexOf('udf') != -1)))
            {
                continue;
            }
            if(trim(field.value)=="")
            {
                alert(mandatoryArrayDisp[i].replace(/&#39;/g,"") + " " +document.getElementById("mandatoryUDF").innerHTML);
                //console.log("Field ", mandatoryArrayDisp[i]);
                /* console.log("type ", field);
                console.log("value ", field.value);
                console.log("disabled ", field.disabled);
                console.log("style ", field.style);
                console.log("display ", field.style.display); */
                if(mandatoryArrayDisp[i] != "Description")
                {
                    field.focus();
                }
                //console.log("returning False");
                return false;
            }
        }
        //debugger;
        if(documentForm.name == "WorkOrderForm")
        {
            checkUserExists(form);
        }
        if(documentForm.name=="BulkEditRequestForm")
        {
            return true;
        }
    }
    catch(e)
    {
        //alert("exception : "+e.message);
        //console.debug("Exception :",e);
        //console.debug("Line :",e.lineNumber);
        return false;
    }
    return false;
}


function populatePriorityMatrix(impactID, urgencyID, priorityID, priorityEditable, isBulkEdit) {
    var imp = $(impactID);
    var urg = $(urgencyID);
    var priority = $(priorityID);
    if(imp && urg) {
        if(priorityEditable) { // if priority editable
            var impact = imp.value;
            var urgency = urg.value;
            var id = impact+"##"+urgency;
            //console.debug("id is ",id);
            if(priMatrixArray[id] != null) {
                priority.value = priMatrixArray[id];
            }
        }
        else {
            var impact = imp.value;
            var urgency = urg.value;
            var id=impact+"##"+urgency;
            if(priMatrixArray[id] != null) {
                priority.value = priMatrixArray[id];
                var priorityName = priorityArray[priority.value];
                parent.document.getElementById("Priority_Phrase").innerHTML = priorityName;
            }else {
                parent.document.getElementById("Priority_Phrase").innerHTML = '-';
                if(isBulkEdit){priority.value = '-1';}
                else{priority.value = '0';}
            }
        }

    }
}

function initPriorityMatrix(impactID, urgencyID, priorityID, priorityEditable , isBulkEdit) {
    if($(impactID) && $(urgencyID)) {
        Event.observe(impactID, 'change', function() { parent.populatePriorityMatrix(impactID, urgencyID, priorityID, priorityEditable, isBulkEdit); });
        Event.observe(urgencyID, 'change', function() { parent.populatePriorityMatrix(impactID, urgencyID, priorityID, priorityEditable, isBulkEdit); });
    }
}


