/* $Id: PopCalendar.js,v 1.35.2.1 2008/12/29 09:34:33 srikrishnan Exp $ */


var selMonth = null;
var selYear = null;
var selDate = new Date().getDate();
var actDate = selDate;

var validateFunc = null;
var validateCtx = null;
var validateArgs = null;

function showPreviousMonth(displayTime) {
    //console.debug("CALENDAR : ", selDate, selMonth, selYear);
    selDate = actDate;
	if(selMonth == 0) {
		var dtObj = new Date();
        dtObj.setDate(selDate);
        dtObj.setMonth(11);
        dtObj.setFullYear(selYear - 1);
        createSDPCalendar(dtObj, displayTime);
	}
	else {
		var dtObj = new Date();
        dtObj.setDate(selDate);
        dtObj.setMonth(selMonth - 1);
        dtObj.setFullYear(selYear);
        //console.debug("selDAte ",selDate, dtObj);
        // check if previous month does not has that date
        if(selDate != dtObj.getDate()) {
		/* if(selDate > 28 && selMonth == 2) { */
			if(selMonth - 1 != dtObj.getMonth()) {
				dtObj.setDate(1);
				dtObj.setTime(dtObj.getTime() - (24*60*60*1000));
			}
		}
		createSDPCalendar(dtObj, displayTime);
	}
}

function showNextMonth(displayTime) {
    //console.debug("CALENDAR : ", selDate, selMonth, selYear);
    selDate = actDate;
	if(selMonth == 11) {
		var dtObj = new Date();
        dtObj.setDate(selDate);
		dtObj.setMonth(0);
		dtObj.setFullYear(selYear + 1);
		createSDPCalendar(dtObj, displayTime);
	}
	else {
		var dtObj = new Date();
        dtObj.setDate(selDate);
		dtObj.setFullYear(selYear);
		dtObj.setMonth(selMonth + 1);
        // check if next month does not has that date
        //console.debug("selDAte ",selDate, dtObj.getDate());
        if(selDate != dtObj.getDate()) {
		/* if(selDate > 28 && selMonth == 0) { */
			if(selMonth + 1 != dtObj.getMonth()) {
				dtObj.setDate(1);
				dtObj.setTime(dtObj.getTime() - (24*60*60*1000));
			}
		}
		createSDPCalendar(dtObj, displayTime);
	}
}

function showPreviousYear(displayTime) {
    selDate = actDate;
	var dtObj = new Date();
    dtObj.setDate(selDate);
	dtObj.setMonth(selMonth);
	dtObj.setFullYear(selYear - 1);
	if(selDate > 28 && selMonth == 1) {
		if(selMonth != dtObj.getMonth()) {
			dtObj.setDate(1);
			dtObj.setTime(dtObj.getTime() - (24*60*60*1000));
		}
	}
	createSDPCalendar(dtObj, displayTime);
}

function showCurrentDate(displayTime) {
	var dtObj = new Date();
	createSDPCalendar(dtObj, displayTime);
}

function showNextYear(displayTime) {
    selDate = actDate;
	var dtObj = new Date();
    dtObj.setDate(selDate);
	dtObj.setMonth(selMonth);
	dtObj.setFullYear(selYear + 1);
	if(selDate > 28 && selMonth == 1) {
		if(selMonth != dtObj.getMonth()) {
			dtObj.setDate(1);
			dtObj.setTime(dtObj.getTime() - (24*60*60*1000));
		}
	}
	createSDPCalendar(dtObj, displayTime);
}

var monthNames = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
var monthNames_i18n = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
//var monthNames_i18n = new Array("sdp.month.jan", "sdp.month.feb", "sdp.month.mar", "sdp.month.apr", "sdp.month.may", "sdp.month.jun", "sdp.month.sdp.month.jul", "sdp.month.aug", "sdp.month.sep", "sdp.month.oct", "sdp.month.nov", "sdp.month.dec");

/**
 * Executes the provided validation function in initCalendar
 * The provided function should return a boolean result
 * If no such fuction is provided it will return true
 */
function validateDate() {
    if(validateFunc) {
        return validateFunc.apply(validateCtx, validateArgs);
    }
    else {
        return true;
    }
}

function selectDate(close, displayTime, date, month, year) {
	if(date != null) {
		selDate = parseInt(date/10) + "" + parseInt(date%10);  // date
	}
	if(month == null) {
		month = selMonth;
	}
	if(year == null) {
		year = selYear;
	}
    //console.debug("Selected ",selDate, month, year);
	var newTime, oldTime, newDispTime, oldDispTime;

    // calculate new date
    if(displayTime) {
		var hrs = document.getElementById("hrs").value;
		var mins = document.getElementById("mins").value;
		if(parseInt(hrs) < 10) {
			hrs = "0" + hrs;
		}
		if(parseInt(mins) < 10) {
			mins = "0" + mins;
		}
		if(parent[currentField + "_Format"] == "%d %b %Y, %H:%M:00") {
            var date = new Date();
            date.setDate(selDate);    // set Date first - so that that date is present in the seleted month
            date.setYear(year);       // set Year next - so that selected month in the selected year has exact same no of days (leap/non-leap)
            date.setMonth(month);
            date.setHours(hrs);
            date.setMinutes(mins);
            if(selDate != date.getDate()) {     // Date Correction - incase of leap/non-leap
                date.setDate(selDate);
            }
            if(month != date.getMonth()) {      // Month Correction - incase of leap/non-leap
                date.setMonth(month);
            }
            //console.debug("Date is ", date);
            //document.getElementById(currentField).value = date.getTime();
            //document.getElementById(currentField + "_Display").value = selDate + " " + monthNames[month] + " " + year + ", " + hrs + ":" + mins + ":00";
            oldTime = document.getElementById(currentField).value;
            newTime = date.getTime();
            //console.debug(" new Time is ", new Date(newTime));
            oldDispTime = document.getElementById(currentField + "_Display").value;
            newDispTime = selDate + " " + monthNames[month] + " " + year + ", " + hrs + ":" + mins + ":00";
        }
        else if(parent[currentField + "_Format"] == "%Y-%m-%d") {
            //document.getElementById(currentField).value = year + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + selDate;
            oldTime = document.getElementById(currentField).value;
            newTime = year + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + selDate;
        }
	//SD-13956: Creating a flash report using from , to option, clicking on the count shows empty page
 	else if(parent[currentField + "_Format"] == "%Y/%m/%d") {
            //document.getElementById(currentField).value = year + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + selD    ate;
            oldTime = document.getElementById(currentField).value;
            newTime = year + "/" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "/" + selDate;
        }
        else if(parent[currentField + "_Format"] == "%d-%m-%Y") {
            //document.getElementById(currentField).value = selDate + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + year;
            oldTime = document.getElementById(currentField).value;
            newTime = selDate + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + year;
        }
    }
	else {
		if(parent[currentField + "_Format"] == "%d %b %Y, %H:%M:00") {
            //document.getElementById(currentField).value = selDate + " " + monthNames[month] + " " + year;
            oldTime = document.getElementById(currentField).value;
            newTime = selDate + " " + monthNames[month] + " " + year;
        }
        else if(parent[currentField + "_Format"] == "%Y-%m-%d") {
            //document.getElementById(currentField).value = year + "-" +(parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + selDate;
            oldTime = document.getElementById(currentField).value;
            newTime = year + "-" +(parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + selDate;
        }
	//SD-13956: Creating a flash report using from , to option, clicking on the count shows empty page
 	else if(parent[currentField + "_Format"] == "%Y/%m/%d") {
            //document.getElementById(currentField).value = year + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + selD    ate;
            oldTime = document.getElementById(currentField).value;
            newTime = year + "/" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "/" + selDate;
        }
        else if(parent[currentField + "_Format"] == "%d-%m-%Y") {
            //document.getElementById(currentField).value = selDate + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + year;
            oldTime = document.getElementById(currentField).value;
            newTime = selDate + "-" + (parseInt((month+1)/10) + "" + parseInt((month+1)%10)) + "-" + year;
        }
    }

	// set date
    //console.debug("setting date to ", newTime, new Date(newTime), newDispTime);
    if(displayTime && parent[currentField + "_Format"] == "%d %b %Y, %H:%M:00") {
        document.getElementById(currentField).value = newTime;
        document.getElementById(currentField + "_Display").value = newDispTime;
    }
    else {
        document.getElementById(currentField).value = newTime;
    }

    // check for new date validity
    // validation function passed is responsible for the appropriate user message to be thrown
    var validationResult = validateDate();
    if(validationResult == false) {
        //if date is not valid revert back
        if(parent[currentField + "_Format"] == "%d %b %Y, %H:%M:00") {
            document.getElementById(currentField).value = oldTime;
            document.getElementById(currentField + "_Display").value = oldDispTime;
        }
        else {
            document.getElementById(currentField).value = oldTime;
        }
    }
    else {
        // validation successfull. if any post processing function is provided. execute it.
        if(date != null) {
            if(parent['CB_Func'] != null && parent['CB_Func_args'] != null){
                var arguments = parent['CB_Func_args'];
                var ctx = arguments.splice(0,1);
                var callback = parent['CB_Func'];
                callback.apply(ctx, arguments);
                parent['CB_Func'] = undefined;
                parent['CB_Func_args'] = undefined;
            }
            if(close) {
	        	closeCalDialog();
            }
        }
    }
}


function createSDPCalendar(dateObj, displayTime) {
    selDate = dateObj.getDate();
	selMonth = dateObj.getMonth();
	selYear = dateObj.getFullYear();
    //console.debug("SDP CALENDAR : ", selDate, selMonth, selYear);
	var date = dateObj.getDate();
	var selHrs = dateObj.getHours();
	var selMins = dateObj.getMinutes();
	dateObj.setMonth(selMonth);
	dateObj.setFullYear(selYear);
	dateObj.setDate(1);
	var totalDays = 35;
	if(dateObj.getDay() > 4 && selMonth != 1) {
		totalDays = 42;
	}
	dateObj.setTime(dateObj.getTime() - (24*dateObj.getDay()*60*60*1000));
	var year = dateObj.getFullYear();
	var month = dateObj.getMonth();
	var day = dateObj.getDay();
	var time = dateObj.getTime();

	var table = "<table id='Calendar_small' class='jsCalendar' cellspacing='0' cellpadding='0'>";
	table = table.concat("<tr bgcolor='#E4E9F1'><td onMouseDown='captureCalDialog(event)' class='dragPopup' colspan='7' align='center' height='30' valign='middle' style='padding:4px;' width='100%'><font style='font-size:11px;font-weight:bold;'>");
	table = table.concat(getMessageForKey(monthNames_i18n[selMonth]) + " " + selYear);
	table = table.concat("</font><span class='CloseBtnBlueSmall' style='padding-left:50px;'><img src='/images/bt_close_icon_blue.gif' onClick='closeCalDialog();'></span></td></tr>");
	table = table.concat("<tr class='DashboardTableColor' height='22'><td align='center'><a class='navButtons' href='javascript:void(0);' onclick='showPreviousYear(" + displayTime + ");'><<</a></td><td align='center'><a class='navButtons' href='javascript:void(0);' onClick='showPreviousMonth(" + displayTime + ");'><</a></td><td colspan='3' align='center'> <a href='javaScript:void(0)' class='navButtons' onClick='showCurrentDate("+displayTime+");'><strong>"+ "Today" + "</strong></a></td><td align='center'><a class='navButtons' href='javascript:void(0);' onClick='showNextMonth(" + displayTime + ");'>></a></td><td align='center'><a class='navButtons' href='javascript:void(0);' onclick='showNextYear(" + displayTime + ");'>>></a></td></tr>");
	table = table.concat("<tr><th width='14.2%' class='th-bluebg'>Sun</th>");
	table = table.concat("<th width='14.2%' class='th-graybg'>Mon</th>");
	table = table.concat("<th width='14.2%' class='th-bluebg'>Tue</th>");
	table = table.concat("<th width='14.2%' class='th-graybg'>Wed</th>");
	table = table.concat("<th width='14.2%' class='th-bluebg'>Thu</th>");
	table = table.concat("<th width='14.2%' class='th-graybg'>Fri</th>");
	table = table.concat("<th class='th-bluebg'>Sat</th></tr>");
	var cssClass = "oddRow";
	for(var cnt=0; cnt<totalDays; cnt++) {
		if(cnt % 7 == 0) {
			table = table.concat("<tr>");
		}
		var tdClass = cssClass
		if(cnt % 7 == 0 || cnt % 7 == 6) {
			tdClass = tdClass + " holiday";
		}
		if(dateObj.getDate() == date && dateObj.getMonth() == selMonth) {
			tdClass = tdClass + " currdate";
		}
		table = table.concat("<td class='" + tdClass + "' width='30' onClick='selectDate(true, " + displayTime + ", " + dateObj.getDate() + "," + dateObj.getMonth() + ", " + dateObj.getFullYear() + ")'>");
		table = table.concat(dateObj.getDate());
		table = table.concat("</td>");
		if(cnt % 7 == 6) {
			table = table.concat("</tr>");
			if(cssClass.indexOf("oddRow") >= 0) {
				cssClass = "evenRow";
			}
			else {
				cssClass = "oddRow";
			}
		}
		dateObj.setTime(dateObj.getTime() + (24*60*60*1000));
	}
	if(displayTime) {
		table = table.concat("<tr height='30'><td colspan='7' align='center' bgcolor='#e1e1e1'><strong>"+getMessageForKey('Time')+"</strong>&nbsp;<select id='hrs' onChange='selectDate(false, " + displayTime + ");'>");
		for(var hrs=0; hrs<24;hrs++) {
			if(hrs == selHrs) {
				table = table.concat("<option selected value='"+ hrs +"'>" + hrs + "</option>")
			}
			else {
				table = table.concat("<option value='"+ hrs +"'>" + hrs + "</option>")
			}
		}
		table = table.concat("</select>(hh)&nbsp;:&nbsp;<select id='mins' onChange='selectDate(false, " + displayTime + ");'>");
		for(var mins=0; mins<60;mins=mins+5) {
			if(mins == selMins) {
				table = table.concat("<option selected value='"+ mins +"'>" + mins + "</option>")
			}
			else {
				table = table.concat("<option value='"+ mins +"'>" + mins + "</option>")
			}

		}
		table = table.concat("</select>(mm)</td></tr>");
	}
	table = table.concat("</table>");
	if(displayTime) {
		showCalDialog(table, 'closeButton=no,height=250,position=relative,srcElement=' + currentField + "_Display");
	}
	else {
		showCalDialog(table, 'closeButton=no,height=250,position=relative,srcElement=' + currentField);
	}
    //	document.getElementById("Calendar").innerHTML = table;
}

var currentField = null;

/**
 * This is the main method that initializes the calendar
 * timeField        - ID of the field whose time/date value has to be changed
 * displayTime      -
 * format           - date format
 * callback         - name of any post processor function that needs to be called after a new date is selected
 * cbArgs           - an array of arguments required for the callback function. The first argument has to be the scope. if none use window [window, arg1, arg2]
 * validateFunction - any validation required. pass the validation  function name
 * validateContext  - scope under which the function will execute. if none you can pass null or window
 * validateArguments- an array of arguments to the validation function [arg1, arg2]. if none pass [] instead of null.
 */
function initCalendar(timeField, displayTime, format, callback, cbArgs, validateFunction, validateContext, validateArguments) {
	currentField = timeField;
	var value = document.getElementById(timeField).value;
	var dt = new Date();
	if(value != '' && value != '-') {
		// - in the value is not parsed properly. So as a fix replaceing - with empty space before parsing
		if(isNaN(value)) {
			value = value.replace(/-/g, "/");
			var time = Date.parse(value);
			dt.setTime(time);
		}
		else {
			dt.setTime(value);
		}

	}
	if(displayTime != null) {
		showTime = displayTime;
	}
    actDate = dt.getDate();
	if(displayTime != null) {
		createSDPCalendar(dt, displayTime);
	}
	else {
		createSDPCalendar(dt, true);
	}
	if(format == null) {
		format = "%d %b %Y, %H:%M:00";
	}
	parent[timeField + "_Format"] = format;
    parent['CB_Func'] = callback;
    parent['CB_Func_args'] = cbArgs;

    if(validateFunction) {
        validateFunc = validateFunction;
        validateCtx = (validateContext == null) ? window : validateContext;
        validateArgs = validateArguments;
    }
    else {
        validateFunc = validateCtx = validateArgs = null;
    }
}


var calDialog, calDoc, calSrcEl, calCloseOnEscKey = true, calCloseOnBodyClick = false, califrameIEHack;
var calDialogProperties = new Array("position", "top", "left", "height", "width", "srcElement", "modal", "draggable", "title", "closeButton", "calCloseOnEscKey", "transitionType", "transitionInterval","calCloseOnBodyClick");

function showCalDialog(content, features, callBackFunc) {
	if (typeof(features) == "undefined") var features = "position=absmiddle";
	features = features.split(",");

	var featurePresent;
	for (var i = 0; i < calDialogProperties.length; i++) {
		featurePresent = false;
		for (var j = 0; j < features.length; j++) {
			if (features[j].indexOf(calDialogProperties[i]) >= 0) {
				featurePresent = true;
				break;
			}
 		}

		self["calDialog_" + calDialogProperties[i]] = (featurePresent) ? features[j].substr(features[j].indexOf("=") + 1, features[j].length).trim() : "undefined";
	}

	if (document.getElementById("_CALDIALOG_LAYER") == null) {
		calDialog = document.createElement("DIV");
		calDialog.id = "_CALDIALOG_LAYER";
		document.body.appendChild(calDialog);
	} else {
		calDialog = document.getElementById("_CALDIALOG_LAYER");
        calDialog.innerHTML = "";
        calDialog.style.width = "";
        calDialog.style.height = "";
		closeCalDialog();
	}

	var content = '<div id="_CALDIALOG_CONTENT">' + content + '</div>';

	var box = '<table class="DialogBox" border="0" cellspacing="0" cellpadding="0"><tr><td class="boxTL"><img src="/images/spacer.gif" width="24" height="1"></td>';

	if (calDialog_draggable != "undefined" && calDialog_draggable == "no") box += '<td class="boxHeader">';
	else box += '<td class="boxHeader drag" onMouseDown="captureCalDialog(event)">';

	if (calDialog_title != "undefined") {
		if (calDialog_title.charAt(0) == "'" && calDialog_title.charAt(calDialog_title.length - 1) == "'")
			calDialog_title = calDialog_title.substr(1, calDialog_title.length - 2);
		if (calDialog_title.trim().length == 0)
			calDialog_title = "&nbsp;";
	} else calDialog_title = "&nbsp;";

	box += calDialog_title + '</td><td class="boxCtrlButtonPane">';

	if (calDialog_closeButton != "undefined" && calDialog_closeButton == "no") box += '&nbsp;</td>';
	else box += '<input type="button" class="closeButton" onClick="closeCalDialog()"></td>';

	box += '<td class="boxTR"><img src="/images/spacer.gif" width="24" height="1"></td></tr><tr><td class="boxML"><img src="/images/spacer.gif" width="1" height="1"></td><td colspan="2" class="boxContent">' + content + '</td><td class="boxMR"><img src="/images/spacer.gif" width="1" height="1"></td></tr>';
	box += '<tr><td class="boxBL"><img src="/images/spacer.gif" width="1" height="1"></td><td class="boxBC" colspan="2"><img src="/images/spacer.gif" width="1" height="1"></td><td class="boxBR"><img src="/images/spacer.gif" width="1" height="1"></td></tr></table>';

	calDialog.style.visibility = "visible";

	var showInBox = true;
	if (calDialog_closeButton != "undefined")
		if (calDialog_title == "&nbsp;" && calDialog_closeButton == "no") showInBox = false;

	if (showInBox)
		calDialog.innerHTML = "<table cellpadding='0' cellspacing='0'><tr><td height='100%' style='display:block'>" + box + "</td></tr></table>";
	else
		calDialog.innerHTML = "<table cellpadding='0' cellspacing='0'><tr><td height='100%' style='display:block'>" + content + "</td></tr></table>";

	calDialog.style.position = "absolute";
	calDialog.style.left = "-1000px";
	calDialog.style.top = "-1000px";
	calDialog.style.zIndex = "105";

	var scriptTags = calDialog.getElementsByTagName("SCRIPT");
	for (var i = 0; i < scriptTags.length; i++) {
		var scriptTag = document.createElement("SCRIPT");
		scriptTag.type = "text/javascript";
		scriptTag.language = "javascript";
		if (scriptTags[i].src != "") { scriptTag.src = scriptTags[i].src;}
		scriptTag.text = scriptTags[i].text;

		if (typeof document.getElementsByTagName("HEAD")[0] == "undefined") {
			document.createElement("HEAD").appendChild(scriptTag)
		} else {
			document.getElementsByTagName("HEAD")[0].appendChild(scriptTag);
		}
	}

	if (browser_opera) {
		var temp = content;
		var styleTags = calDialog.getElementsByTagName("STYLE");
		for (var i = 0; i < styleTags.length; i++) {
			styleTags[i].innerHTML = temp.substring(temp.indexOf("<style>") + 7, temp.indexOf("</style>") - 1);
			temp = temp.substring(temp.indexOf("</style>") + 8, temp.length);
		}
	}

	if (calDialog_width != "undefined") {
		if (browser_ie)	calDialog.childNodes[0].style.width = parseInt(calDialog_width) + "px";
		else if (browser_nn4 || browser_nn6) calDialog.childNodes.item(0).style.width = parseInt(calDialog_width) + "px";
	}

	if (calDialog_height != "undefined") {
		if (browser_ie) calDialog.childNodes[0].style.height = parseInt(calDialog_height) + "px";
		else if (browser_nn4 || browser_nn6) calDialog.childNodes.item(0).style.height = parseInt(calDialog_height) + "px";
	}

	calDialogContent = getObj("_CALDIALOG_CONTENT");

	var left = 0, top = 0;

	if (browser_opera) {
		if (calDialog_width != "undefined") {
			calDialogContent.style.width = parseInt(calDialog_width) + "px";
		} else {
			calDialogContent.style.width = calDialogContent.offsetWidth + "px";
			calDialog.style.width = calDialogContent.offsetWidth + "px";
		}
	}

	if (browser_nn4 || browser_nn6 || browser_ie) {
		if (calDialog_width != "undefined") calDialogContent.style.width = parseInt(calDialog_width) + "px";
		else calDialogContent.style.width = (calDialogContent.offsetWidth + 20) + "px";
	}

	if (calDialog_height != "undefined") {
		if (browser_ie && (parseInt(calDialog_height) < calDialogContent.offsetHeight)) left = -15;
		calDialogContent.style.height = parseInt(calDialog_height) + "px";
    }
    calDialogContent.style.overflow = "auto";

	var width = calDialog.offsetWidth;
	var height = calDialog.offsetHeight;
	calDoc = findDocDim();

	if (calDialog_calCloseOnEscKey != "undefined" && calDialog_calCloseOnEscKey == "no") calCloseOnEscKey = false;
	else calCloseOnEscKey = true;

	if (calDialog_calCloseOnBodyClick != "undefined" && calDialog_calCloseOnBodyClick == "yes") calCloseOnBodyClick = true;
	else calCloseOnBodyClick = false;

	if (!browser_opera) {
		if (calDialog_modal != "undefined" && calDialog_modal == "yes") freezeCalBackground();
		else if (document.getElementById("CalFreezeLayer") != null) document.body.removeChild(document.getElementById("CalFreezeLayer"));
	}

	if (calDialog_left != "undefined")	left += parseInt(calDialog_left);
	if (calDialog_top != "undefined") top += parseInt(calDialog_top);

	if (calDialog_position != "undefined" && calDialog_position == "relative") {
		if (calDialog_srcElement != "undefined") calSrcEl = getObj(calDialog_srcElement);
		else if (calSrcEl == null) calSrcEl = document.body;

		if ((width - (calDoc.width - findPosX(calSrcEl))) + scrollConst > 0)
			left += findPosX(calSrcEl) + ((calSrcEl.offsetWidth) ? calSrcEl.offsetWidth : 0) - width;
		else
			left += findPosX(calSrcEl);

		if ((height - (calDoc.height - findPosY(calSrcEl))) + scrollConst > 0)
			top += findPosY(calSrcEl) - height;
		else
			top += findPosY(calSrcEl) + ((calSrcEl.offsetHeight) ? calSrcEl.offsetHeight : 0) + 2;
	} else if (calDialog_position != "undefined" && calDialog_position == "absolute") {
		left += document.body.scrollLeft;
		top += document.body.scrollTop;
	} else {
		left = (calDoc.width / 2 ) - (width / 2) + document.body.scrollLeft;
		top = (calDoc.height / 2) - (height / 2) + document.body.scrollTop;
	}

	left = (left > 0) ? left : 0;
	top = (top > 0) ? top : 0;

	if (calDialog_transitionType != "undefined") {
		if (calDialog_transitionInterval == "undefined") calDialog_transitionInterval = 10;
		MC_Effect.init(
                       {
                           type : calDialog_transitionType, speed : calDialog_transitionInterval ,
                           layerId : "_CALDIALOG_LAYER", layerTop : top, layerLeft : left
                       }
                       );
		MC_Effect.display();
	} else {
		calDialog.style.left = parseInt(left) + "px";
		calDialog.style.top = parseInt(top) + "px";
	}

	if (browser_ie && !browser_opera) {
		califrameIEHack = document.createElement("IFRAME");
		califrameIEHack.scrolling = "no";
		califrameIEHack.frameBorder = 0;
        if(window["CONTEXT_PATH"] != null)
        {
            califrameIEHack.src= CONTEXT_PATH + "/framework/html/blank.html";
        }
		califrameIEHack.style.position = "absolute";
		califrameIEHack.style.zIndex = "104";
		califrameIEHack.style.filter = 'progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0)';

		if (calDialog_modal != "undefined" && calDialog_modal == "yes") {
			califrameIEHack.style.width = document.getElementById("CalFreezeLayer").style.width;
			califrameIEHack.style.top = "0px";
			califrameIEHack.style.left = "0px";
		} else {
			califrameIEHack.style.width = calDialog.offsetWidth + "px";
			califrameIEHack.style.height = calDialog.offsetHeight + "px";
			califrameIEHack.style.top = parseInt(top) + "px";
			califrameIEHack.style.left = parseInt(left) + "px";
		}

		document.body.appendChild(califrameIEHack);
	}

	if (!browser_opera) {
		if (calDialog_modal != "undefined" && calDialog_modal == "yes") {
			document.getElementById("CalFreezeLayer").style.height = (document.body.offsetHeight + document.body.scrollHeight) + "px";
			if (browser_ie) califrameIEHack.style.height = document.getElementById("CalFreezeLayer").style.height;
		}
	}

	if (callBackFunc){	callBackFunc();}
	return calDialog;
}

function freezeCalBackground() {
	var oFreezeLayer = document.createElement("DIV");
	oFreezeLayer.id = "CalFreezeLayer";
	oFreezeLayer.className = "freezeLayer";
	oFreezeLayer.style.width = "100%";
	oFreezeLayer.style.zIndex = "99";

	document.body.appendChild(oFreezeLayer);
}

var diffLeft=0, diffTop=0;

function captureCalDialog(ev) {
	calDialog.style.cursor = "move";

	if (browser_ie) {
		diffLeft = window.event.clientX + document.body.scrollLeft - parseInt(findPosX(calDialog));
		diffTop = window.event.clientY + document.body.scrollTop - parseInt(findPosY(calDialog));
	} else if (browser_nn4 || browser_nn6) {
		diffLeft = ev.pageX - parseInt(findPosX(calDialog));
		diffTop = ev.pageY - parseInt(findPosY(calDialog));
	}

	document.onmousemove = moveCalDialog;
	document.onmouseup = releaseCalDialog;
}

function moveCalDialog(ev) {
	clearTextSelection();
	if (browser_ie) {
		var left = window.event.clientX + document.body.scrollLeft - diffLeft;
		var top = window.event.clientY + document.body.scrollTop - diffTop;

		left = (left >= 0) ? left : 0;
		top = (top >= 0) ? top : 0;

		if (document.getElementById("CalFreezeLayer") != null || browser_opera) {
			calDialog.style.left = left + "px";
			calDialog.style.top = top + "px";
		} else {
			calDialog.style.left = califrameIEHack.style.left = left + "px";
			calDialog.style.top = califrameIEHack.style.top = top + "px";
		}
	} else if (browser_nn4 || browser_nn6) {
		calDialog.style.left = ((ev.pageX - diffLeft > 0) ? ev.pageX - diffLeft : 0) + "px";
		calDialog.style.top = ((ev.pageY - diffTop > 0) ? ev.pageY - diffTop : 0) + "px";
	}
}

function releaseCalDialog() {
	calDialog.style.cursor = "default";
	document.onmousemove = null;
	document.onmouseup = null;
}

function closeCalDialog(callBackFunc) {
	if (calDialog != null && calDialog.style.visibility != "hidden") {
		calDialog.style.visibility = "hidden";
		if (document.getElementById("CalFreezeLayer") != null) document.body.removeChild(document.getElementById("CalFreezeLayer"));
		if (browser_ie && !browser_opera) {
			document.body.removeChild(califrameIEHack);
			califrameIEHack = null;
		}
		calCloseOnBodyClick = false;

		if (typeof callBackFunc != "undefined")	callBackFunc();
	}
	if(document.getElementById('_CUSTOMALERTFRAME') != null) {
		document.getElementById("_CUSTOMALERTFRAME").src = '/framework/html/blank.html';
	}
}

document.onkeydown = function(ev) {
	if (browser_ie) var keyCode = window.event.keyCode;
	else if (browser_nn4 || browser_nn6) var keyCode = ev.which;

	if (keyCode == 27 && calCloseOnEscKey == true && calDialog != null && calDialog.style.visibility != "hidden")
		closeCalDialog();
	else if (keyCode == 27 && closeOnEscKey == true && oDialog != null && oDialog.style.visibility != "hidden") {
		closeDialog();
	}
}

function displayClientTime(calId, todaysDate) {
	var date = new Date();
	var addNew = false;
	var val = document.getElementById(calId).value;
	if(val == '' || val == '0' || val == '-1') {
		if(todaysDate == null) {
			document.getElementById(calId+'_Display').value = "";
			document.getElementById(calId).value = "";
			return;
		}
		else if(todaysDate) {
			// To display current time
			document.getElementById(calId).value=date.getTime();
		}
	}
	var monthObject = new Object();
	monthObject["0"] = "Jan";
	monthObject["1"] = "Feb";
	monthObject["2"] = "Mar";
	monthObject["3"] = "Apr";
	monthObject["4"] = "May";
	monthObject["5"] = "Jun";
	monthObject["6"] = "Jul";
	monthObject["7"] = "Aug";
	monthObject["8"] = "Sep";
	monthObject["9"] = "Oct";
	monthObject["10"] = "Nov";
	monthObject["11"] = "Dec";

	if(addNew) {
		document.getElementById(calId).value = date.getTime();
	}
	else {
		date.setTime(document.getElementById(calId).value);
	}
	var min = date.getMinutes();
	if(min >=0 && min <10) {
		min = '0' + min;
	}
	document.getElementById(calId+'_Display').value = date.getDate() + " " + monthObject[date.getMonth()] + " " + date.getFullYear() + ", " + date.getHours() + ":" + min + ":00";
}

/*
document.onmousedown = function(ev) {
	if (browser_ie) {
		calSrcEl = window.event.srcElement;
		var x = window.event.x;
		var y = window.event.y;
	} else if (browser_nn4 || browser_nn6) {
		calSrcEl = ev.target;
		var x = ev.pageX;
		var y = ev.pageY;
	}

	if (typeof calCloseOnBodyClick != "undefined" && calCloseOnBodyClick == true && calDialog != null && calDialog.style.visibility != "hidden") {
		if ((x < findPosX(calDialog) || x >= findPosX(calDialog) + calDialog.offsetWidth) || (y < findPosY(calDialog) || y >= findPosY(calDialog) + calDialog.offsetHeight))
			closeCalDialog();
	}
	else if (typeof closeOnBodyClick != "undefined" && closeOnBodyClick == true && oDialog != null && oDialog.style.visibility != "hidden") {
		if ((x < findPosX(oDialog) || x >= findPosX(oDialog) + oDialog.offsetWidth) || (y < findPosY(oDialog) || y >= findPosY(oDialog) + oDialog.offsetHeight))
			closeDialog();
	}
}
*/
