/* $Id: ajax.js,v 1.54.2.1 2008/12/23 10:23:28 navneet Exp $ */

// global variables
var sdp_reqForm = null;
var technicianObj = null;
var form_name = null;
var groupCommonOption = null;

var resourceBox = null;

/** this function is similar to submitGroupID but takes the DOM IDs of group and technician
*  uses the same processStateChange function
*/
function changeTech(grpId, techId) {
	var group = $(grpId);
	var tech = $(techId);
	var groupValue = group.value;

	groupCommonOption = $('groupFirstOption');
	technicianObj = tech;
	form_name = "PasswordResetForm";
	if(groupValue == -1) {
		groupValue = 0;
	}

	url = "/servlet/HdClientUtilServlet?group="+groupValue;
	req = getXMLHttpRequest();
	if(req) {
		req.onreadystatechange = processStateChange;
		req.open("GET", url, true);
		req.send(null);
	}
}

function submitGroupID(form) {
	sdp_reqForm = form;
	groupID = sdp_reqForm.group.value;
	siteID = sdp_reqForm.siteID.value;
	technicianObj = sdp_reqForm.technician;
	groupCommonOption = $('selectGroup');
	form_name = sdp_reqForm.name;
	if(form_name == 'BulkEditRequestForm' && groupID == '-1') {
		groupID = 0;
	}
	url = "/servlet/HdClientUtilServlet?group="+groupID+"&siteID="+siteID;
	req = getXMLHttpRequest();
	if(req) {
		req.onreadystatechange = processStateChange;
		req.open("GET", url, true);
		req.send(null);
	}
}

function processStateChange()
{
	if (req.readyState == 4)
	{ // Complete
		if (req.status == 200)
		{ // OK response

			var nameNode = req.responseXML.getElementsByTagName("technicians")[0];
			var objNode = req.responseXML.getElementsByTagName("object")[0];
			var objTextNode = objNode.childNodes[0];
            var nameNode1 = req.responseXML.getElementsByTagName("details");
            var nl= nameNode1.length;

            if(technicianObj!=null)
            {
                technicianObj.options.length = 0;
                if(form_name == 'BulkEditRequestForm')
                {
                    technicianObj.options[0] = new Option('Choose', "-1");
                    technicianObj.options[1] = new Option('NONE', "0");
                }
                else if(form_name == 'PasswordResetForm')
                {
                    technicianObj.options[0] = new Option(groupCommonOption.value, "-1");
                    technicianObj.options[1] = new Option('NONE', "0");
                }
                else
                {
                    technicianObj.options[0] = new Option(groupCommonOption.value, "0");
                }
                for(i=0; i< nl;i++)
                {
                    var keyNode = req.responseXML.getElementsByTagName("key")[i];
                    var keyTextNode = keyNode.childNodes[0];
                    var keyText = keyTextNode.nodeValue;

                    var valueNode = req.responseXML.getElementsByTagName("value")[i];
                    var valueText = valueNode.childNodes[0];
                    var valText = valueText.nodeValue;

                    if(form_name == 'BulkEditRequestForm' || form_name == 'PasswordResetForm')
                    {
                        technicianObj.options[i+2] = new Option(valText, keyText);
                    }
                    else
                    {
                        technicianObj.options[i+1] = new Option(valText, keyText);
                    }
                }
            }
		}
		else
		{
			alert("Problem: " + req.statusText);
		}
	}
}

function constructMandatoryListArray(str)
{
    mandatoryListArray[mlistindex] = str;
    var head = str.substring(0,1);
    var tail = str.substring(1,str.length);
    mandatoryListArrayDisp[mlistindex] = head.toUpperCase() + tail;
    mlistindex++;
}

var sdp_reqForm1 = null;
function fillUserDetails(form)
{
	sdp_reqForm1 = form;
	reqName = sdp_reqForm1.reqName.value;
    reqID = sdp_reqForm1.requesterID.value;
	url = "/servlet/AJaxServlet?action=getUserDetails&search="+reqName+"&reqId="+reqID;
	req1 = getXMLHttpRequest();
	req1.onreadystatechange = processStateChangeUD;
	req1.open("GET", url, true);
	req1.send(null);
}

function processStateChangeUD()
{
	if (req1.readyState == 4)
	{ // Complete
		if (req1.status == 200)
		{ // OK response

			var contactNumber, dept, siteid = undefined;
			//wsID = 0;
			var value = req1.responseText;
            //console.debug("value ",value);
            var data = value.evalJSON();
            //console.debug("data ", data);
            if(data) {
                contactNumber = data.USER_CONTACT;
                dept = data.USER_DEPT;
                siteid = data.USER_SITEID;
            }

            if(!contactNumber) { contactNumber = "" }
            if(!dept) { dept = "" }
            if(!siteid) { siteid = "-1" }

            //console.debug("sdp_reqForm1 ",sdp_reqForm1);
			if(sdp_reqForm1.contactNumber != null)
                sdp_reqForm1.contactNumber.value = contactNumber;
			if(sdp_reqForm1.location != null)
                sdp_reqForm1.location.value = dept;
			/* if(sdp_reqForm1.workstationID != null)
			sdp_reqForm1.workstationID.value = wsID; */
            if(sdp_reqForm1.siteID != null && siteid != 'NOT_IN_SITE') {
                sdp_reqForm1.siteID.value = siteid;
                try {
                    var techList = $('TECHNICIANID');
                    var grpList = $('GROUPID');
                    if(techList) { populateList(techList, siteid, siteTechModel.getSiteTechs, siteTechModel); }
                    if(grpList) { populateList(grpList, siteid, siteGrpModel.getSiteGroups, siteGrpModel); }
                }
                catch(e) { /*
                    In IE when the HOME > My Schedule tab is selected and we add a requester through Ajax in QuickCreate form
                    then the above check "if(techList)" will be true. Because in IE getElementById also return values
                    if the name matches instead of an Id and we will have a field in scheduler page named TECHNICIANID.
                    So subsequently it will enter the if block and throw a JS error
                    THIS TRY CATCH BLOCK IS TO SUPPRESS THAT ERROR. DO NOT REMOVE... */
                }
            }
		}
		else
		{
			alert("Problem: " + req1.statusText);
		}
	}
}

function getResourcesByType(compnentListID, listBoxID)
{
    //get component type
    var componentListBox = $(compnentListID);
    var componentTypeID = componentListBox.value;
    resourceBox = $(listBoxID);
    //console.debug("in getResourcesByType :",componentListBox);
    //console.debug("",resourceBox);
    //url = "/servlet/HdClientUtilServlet?componentTypeId="+componentTypeID;
    var newUrl = '/servlet/HdClientUtilServlet';
    var params = 'componentTypeId=' + componentTypeID;
    var myAjax = new Ajax.Request(newUrl, {method: 'get', parameters: params, onComplete: populateResources});
}

function populateResources(resp, jsonObj)
{
    try{
        var nameNode = resp.responseXML.getElementsByTagName("ResourcesByType")[0];

        var objNode = resp.responseXML.getElementsByTagName("object")[0];
        var objTextNode = objNode.childNodes[0];

        var nameNode1 = resp.responseXML.getElementsByTagName("details");
        var nl= nameNode1.length;
        //console.debug("length = ",nl);
        if(resourceBox!=null)
        {
            resourceBox.options.length = 0;
            //resourceBox.options[0] = new Option("All Assets", "0");
            for(i=0; i< nl;i++)
            {
                var keyNode = resp.responseXML.getElementsByTagName("key")[i];
                var keyTextNode = keyNode.childNodes[0];
                var keyText = keyTextNode.nodeValue;

                var valueNode = resp.responseXML.getElementsByTagName("value")[i];
                var valueText = valueNode.childNodes[0];
                var valText = valueText.nodeValue;

                resourceBox.options[i] = new Option(valText, keyText);
            }
        }
    }catch(e){alert(e);}
}

/* This method will get the call the HdClientUtilServlet to get the list of assets belonging to
* the particular user
*
*/
function getUserAssets(userNameBoxID, targetNodeID,userIDBoxID)
{
    try
    {
        var userNameBox = $(userNameBoxID);
        var userIDBox = $(userIDBoxID);
        var username = userNameBox.value;
        var userid = userIDBox.value;
        var targetListBox = $(targetNodeID);

        // NOTE: The targetListBox will be NULL in case of Standard Edition, then no Ajax request will be sent
        // It will be a text box if a selection has been made from the pop up
        if(targetListBox != null && targetListBox.nodeName == "SELECT") {
            var newUrl = '/servlet/HdClientUtilServlet';
            var params = 'command=getWOAssets&' ;
            params = params + 'userasset=true&';
            params = params + 'username=' + username;
            params = params + '&userid=' + userid;
            //console.debug("params",params);
            //console.debug("targetListBox",targetListBox);
            var myAjax = new Ajax.Request(newUrl, {
                                          method: 'post',
                                          parameters: params,
                                          onComplete: function(resp, jsonObj){ populateListBox(resp, targetListBox, $('chooseAssets').innerHTML, $('noUserAsset').innerHTML );}
            });
        }
        else {
            // fix for closing search user window
            closeSearchWindow();
        }

    }
    catch(e)
    {
        showError(e, "getUserAssets");
    }
}

/* This is a common method to populate any Select List Box in the page given
* the XML response from the server and the DOM reference to the Select Box
*
* @PARAM xmlResp - XMLHttpRequest Object [REQUIRED]
* @PARAM targetListRef - DOM refernce to the the select box that needs to be updated [REQUIRED]
* @PARAM selectOptionMessage - A message String to display the first option eg. "Choose/Select Assets" [OPTIONAL]
* @PARAM noDataMeessage - A message string that will be populated to the Select box when no data is returned from the server [OPTIONAL]
*
* Expected XML response :
* <details> <key>1234</key> <value>navneet.india.adventnet.com</value> </details>  OR
* <entries> <key>1234</key> <value>navneet.india.adventnet.com</value> </entries>
*
* How to Use :
* [If using Prototype.js Ajax.Request()]
* onComplete: function(resp, jsonObj){ populateListBox(resp, targetListBox, "-- Choose Asset --", "No Asset Available")};
* [If using XMLHttpRequest Object directly] - req is an XMLHttpRequest Object
* req.onreadystatechange = function(){ populateListBox(req, targetListBox, "-- Choose Asset --", "No Asset Available")};
*
* The unnamed funtion block will create a closure over the parent function and will have access to its variables
* more on Closures : [See] http://blog.morrisjohns.com/javascript_closures_for_dummies
*/
function populateListBox(xmlResp, targetListRef, selectOptionMessage, noDataMeessage)
{
    try
    {
        //console.debug("response",xmlResp.responseText);
        //console.debug("targetListRef",targetListRef);
        var dataNode = xmlResp.responseXML.getElementsByTagName("details");
        if(dataNode.length == 0) {
            dataNode = xmlResp.responseXML.getElementsByTagName("entries");
        }
        //console.debug("length = ", dataNode.length);
        if(dataNode.length != 0)
        {
            if(targetListRef != null)
            {
                targetListRef.options.length = 0;
                var index = 0;
                if(dataNode.length != 1) {
                	if(selectOptionMessage != null) {
                        targetListRef.options[index] = new Option(selectOptionMessage, "0");
                        ++index;
                	}
                }
                for(i=0; i<dataNode.length; i++)
                {
                    var keyNode = xmlResp.responseXML.getElementsByTagName("key")[i];
                    var keyTextNode = keyNode.childNodes[0];
                    var keyText = keyTextNode.nodeValue;

                    var valueNode = xmlResp.responseXML.getElementsByTagName("value")[i];
                    var valueText = valueNode.childNodes[0];
                    var valText = valueText.nodeValue;

                    targetListRef.options[index] = new Option(valText, keyText);
                    //console.debug("targetListRef.options",targetListRef.options[index]);
                    ++index;
                }
                if(dataNode.length == 1) {
                    if(selectOptionMessage != null) {
 	                	targetListRef.options[index] = new Option(selectOptionMessage, "0");
                        ++index;
 	                }
                }
            }
        }
        else {
            if(noDataMeessage != null && targetListRef != null) {
                targetListRef.options.length = 0;
                targetListRef.options[0] = new Option(noDataMeessage, "0");
            }
        }
        // remove DOM reference
        targetListRef = null;

        // fix for closing search user window
        closeSearchWindow();
    }
    catch(e)
    {
        showError(e, "populateListBox");
    }
}

function closeSearchWindow() {
    //console.debug("closeSearchWindow");
    // fix for closing search user window
    if(parent['selectuser'] != null) {
        //console.debug("22");
        parent['selectuser'].close();
        parent['selectuser'] = null;
    }
}

function getSWF(movieName)
{
	if (navigator.appName.indexOf("Microsoft") != -1)
    {
		return window[movieName];
    }
    else
    {
        return document[movieName];
    }
}

function clearFormValues()
{
	document.getElementById("pendRequestCnt").innerHTML="";
	document.getElementById("compRequestCnt").innerHTML="";
	document.getElementById("slaViolatedCnt").innerHTML="";
}

function getReportDetails(form)
{
	document.getElementById("showFlashReport").style.display = "block";
	document.getElementById("helpContent").style.display = "none";
	generateSWFObject();
	datecrit = FlashReportForm.datecrit.value;
	clearFormValues();
	var value="";
	if (datecrit != "-1")
	{
		basedon0 = FlashReportForm.basedon[0].checked;
		if(basedon0) {
			during = FlashReportForm.during.value;
			value =  "dateCrit@"+datecrit+";"+during;
		}
		basedon1 = FlashReportForm.basedon[1].checked;
		if(basedon1) {
			fromdate = FlashReportForm.preFromDate_tmp.value;
			todate = FlashReportForm.preToDate_tmp.value;
			value =  "dateCrit@"+datecrit+";"+fromdate+";"+todate;
		}
	}
	else if (datecrit == "-1") {
		value="dateCrit@"+datecrit;
	}
    //	getSWF("flashreport").onReloadData(value);
	url = "/servlet/AJaxServlet?action=getReportData&search="+value;
	req1 = getXMLHttpRequest();
	req1.onreadystatechange = getData;
	req1.open("GET", url, true);
	req1.send(null);
}

function getData()
{
	if (req1.readyState == 4)
	{ // Complete
		if (req1.status == 200)
		{ // OK response
			var val="";
			var res=0;
			var value = req1.responseText;
			value = value.replace(/{/g,"");
			value = value.replace(/}/g,"");
			value1=value.split("&");
			for(j=0;j<value1.length;j++){
				value2 = value1[j].split("~");
				if (value2[0]=="Mode") {
				}
				else if(value2[0]=="Stat") {
					value3 = value2[1].split(",");
					for(i=0;i<value3.length;i++){
						res = value3[i].split("=")[1];
						if(value3[i].split("=")[0].match("Pending")) {
							if(res!=null && res!="")
								document.getElementById("pendRequestCnt").innerHTML=res;
						}else if(value3[i].split("=")[0].match("Completed")){
							if(res!=null && res!="")
								document.getElementById("compRequestCnt").innerHTML=res;
						}
					}
					document.getElementById("requestCnt").innerHTML=Number(document.getElementById("pendRequestCnt").innerHTML)+Number(document.getElementById("compRequestCnt").innerHTML);
				}
				else if(value2[0]=="Technician") {
				}
				else if(value2[0]=="SLA") {
					value3 = value2[1].split(",");
					for(i=0;i<value3.length;i++){
						res = value3[i].split("=")[1];
						if(!value3[i].split("=")[0].match("Not Violated")) {
							if(res!=null && res!="")
								document.getElementById("slaViolatedCnt").innerHTML=res;
						}
					}
				}
			}
		}
		else
		{
			alert("Problem: " + req1.statusText);
		}
	}
}
